diff --git a/plugins/imfile/imfile.c b/plugins/imfile/imfile.c
index a5d20823fd..b2ab1886fc 100644
--- a/plugins/imfile/imfile.c
+++ b/plugins/imfile/imfile.c
@@ -30,11 +30,12 @@
 #include <string.h>
 #include <errno.h>
 #include <fcntl.h>
-#include <pthread.h>		/* do NOT remove: will soon be done by the module generation macros */
+#include <pthread.h>
 #include <sys/types.h>
 #include <unistd.h>
 #include <glob.h>
 #include <poll.h>
+#include <json.h>
 #include <fnmatch.h>
 #ifdef HAVE_SYS_INOTIFY_H
 #include <sys/inotify.h>
@@ -85,12 +86,6 @@ static int bLegacyCnfModGlobalsPermitted;/* are legacy module-global config para
 #define INIT_WDMAP_TAB_SIZE 1 /* default wdMap table size - is extended as needed, use 2^x value */
 #define ADD_METADATA_UNSPECIFIED -1
 
-/*
-*	Helpers for wildcard in directory detection
-*/
-#define DIR_CONFIGURED 0
-#define DIR_DYNAMIC 1
-
 /* If set to 1, fileTableDisplay will be compiled and used for debugging */
 #define ULTRA_DEBUG 0
 
@@ -1000,7 +995,7 @@ getFullStateFileName(const uchar *const pszstatefile, uchar *const pszout, const
 	pszworkdir = glblGetWorkDirRaw();
 
 	/* Construct file name */
-	lenout = snprintf((char*)pszout, ilenout, "%s/%s",
+	lenout = snprintf((char*)pszout, ilenout, "%s/%s.json",
 			     (char*) (pszworkdir == NULL ? "." : (char*) pszworkdir), (char*)pszstatefile);
 
 	/* return out length */
@@ -1119,67 +1114,80 @@ static rsRetVal ATTR_NONNULL(1)
 openFileWithStateFile(act_obj_t *const act)
 {
 	DEFiRet;
-	strm_t *psSF = NULL;
 	uchar pszSFNam[MAXFNAME];
-	size_t lenSFNam;
-	struct stat stat_buf;
 	uchar statefile[MAXFNAME];
 	const instanceConf_t *const inst = act->edge->instarr[0];// TODO: same file, multiple instances?
 
 	uchar *const statefn = getStateFileName(act, statefile, sizeof(statefile));
-	DBGPRINTF("trying to open state for '%s', state file '%s'\n", act->name, statefn);
-
-	/* persist state file base name in act, as this may be used for MOVE operations */
-	//free(act->statefile);
-	//CHKmalloc(act->statefile = strdup((char*) statefile));
 
-	/* Get full path and file name */
-	lenSFNam = getFullStateFileName(statefn, pszSFNam, sizeof(pszSFNam));
+	getFullStateFileName(statefn, pszSFNam, sizeof(pszSFNam));
+	DBGPRINTF("trying to open state for '%s', state file '%s'\n", act->name, pszSFNam);
 
 	/* check if the file exists */
-	if(stat((char*) pszSFNam, &stat_buf) == -1) {
+	const int fd = open((char*)pszSFNam, O_CLOEXEC | O_NOCTTY | O_RDONLY, 0600);
+	if(fd < 0) {
 		if(errno == ENOENT) {
 			DBGPRINTF("NO state file (%s) exists for '%s'\n", pszSFNam, act->name);
 			ABORT_FINALIZE(RS_RET_FILE_NOT_FOUND);
 		} else {
-			char errStr[1024];
-			rs_strerror_r(errno, errStr, sizeof(errStr));
-			DBGPRINTF("error trying to access state file for '%s':%s\n",
-			          act->name, errStr);
+			LogError(errno, RS_RET_IO_ERROR,
+				"imfile error trying to access state file for '%s'",
+			        act->name);
 			ABORT_FINALIZE(RS_RET_IO_ERROR);
 		}
 	}
 
-	/* If we reach this point, we have a state file */
+	CHKiRet(strm.Construct(&act->pStrm));
 
-	CHKiRet(strm.Construct(&psSF));
-	CHKiRet(strm.SettOperationsMode(psSF, STREAMMODE_READ));
-	CHKiRet(strm.SetsType(psSF, STREAMTYPE_FILE_SINGLE));
-	CHKiRet(strm.SetFName(psSF, pszSFNam, lenSFNam));
-	CHKiRet(strm.SetFileNotFoundError(psSF, inst->fileNotFoundError));
-	CHKiRet(strm.ConstructFinalize(psSF));
+	struct json_object *jval;
+	struct json_object *json = fjson_object_from_fd(fd);
+	if(json == NULL) {
+		LogError(0, RS_RET_ERR, "imfile: error reading state file for '%s'", act->name);
+	}
 
-	/* read back in the object */
-	CHKiRet(obj.Deserialize(&act->pStrm, (uchar*) "strm", psSF, NULL, act));
-	DBGPRINTF("deserialized state file, state file base name '%s', "
-		  "configured base name '%s'\n", act->pStrm->pszFName,
-		  act->name);
-	/* correct file name (if renamed) TODO: refactor state file! */
-	free(act->pStrm->pszFName);
-	CHKmalloc(act->pStrm->pszFName = ustrdup(act->name));
+	/* we access some data items a bit dirty, as we need to refactor the whole
+	 * thing in any case - TODO
+	 */
+	/* Note: we ignore filname property - it is just an aid to the user. Most
+	 * importantly it *is wrong* after a file move!
+	 */
+	fjson_object_object_get_ex(json, "prev_was_nl", &jval);
+	act->pStrm->bPrevWasNL = fjson_object_get_int(jval);
 
-	strm.CheckFileChange(act->pStrm);
-	CHKiRet(strm.SeekCurrOffs(act->pStrm));
+	fjson_object_object_get_ex(json, "curr_offs", &jval);
+	act->pStrm->iCurrOffs = fjson_object_get_int64(jval);
 
-	/* note: we do not delete the state file, so that the last position remains
-	 * known even in the case that rsyslogd aborts for some reason (like powerfail)
-	 */
+	fjson_object_object_get_ex(json, "strt_offs", &jval);
+	act->pStrm->strtOffs = fjson_object_get_int64(jval);
 
-finalize_it:
-	dbgprintf("state file out %p\n", psSF);
-	if(psSF != NULL)
-		strm.Destruct(&psSF);
+	fjson_object_object_get_ex(json, "prev_line_segment", &jval);
+	const uchar *const prev_line_segment = (const uchar*)fjson_object_get_string(jval);
+	if(jval != NULL) {
+		CHKiRet(rsCStrConstructFromszStr(&act->pStrm->prevLineSegment, prev_line_segment));
+		cstrFinalize(act->pStrm->prevLineSegment);
+		uchar *ret = rsCStrGetSzStrNoNULL(act->pStrm->prevLineSegment);
+		DBGPRINTF("prev_line_segment present in state file 2, is: %s\n", ret);
+	}
 
+	fjson_object_object_get_ex(json, "prev_msg_segment", &jval);
+	const uchar *const prev_msg_segment = (const uchar*)fjson_object_get_string(jval);
+	if(jval != NULL) {
+		CHKiRet(rsCStrConstructFromszStr(&act->pStrm->prevMsgSegment, prev_msg_segment));
+		cstrFinalize(act->pStrm->prevMsgSegment);
+		uchar *ret = rsCStrGetSzStrNoNULL(act->pStrm->prevMsgSegment);
+		DBGPRINTF("prev_msg_segment present in state file 2, is: %s\n", ret);
+	}
+	fjson_object_put(json);
+
+	CHKiRet(strm.SetFName(act->pStrm, (uchar*)act->name, strlen(act->name)));
+	CHKiRet(strm.SettOperationsMode(act->pStrm, STREAMMODE_READ));
+	CHKiRet(strm.SetsType(act->pStrm, STREAMTYPE_FILE_MONITOR));
+	CHKiRet(strm.SetFileNotFoundError(act->pStrm, inst->fileNotFoundError));
+	CHKiRet(strm.ConstructFinalize(act->pStrm));
+
+	CHKiRet(strm.SeekCurrOffs(act->pStrm));
+
+finalize_it:
 	RETiRet;
 }
 
@@ -1193,8 +1201,7 @@ openFileWithoutStateFile(act_obj_t *const act)
 	DEFiRet;
 	struct stat stat_buf;
 
-	// TODO: same file, multiple instances?
-	const instanceConf_t *const inst = act->edge->instarr[0];
+	const instanceConf_t *const inst = act->edge->instarr[0];// TODO: same file, multiple instances?
 
 	DBGPRINTF("clean startup withOUT state file for '%s'\n", act->name);
 	if(act->pStrm != NULL)
@@ -2195,10 +2202,41 @@ CODESTARTwillRun
 	CHKiRet(prop.Construct(&pInputName));
 	CHKiRet(prop.SetString(pInputName, UCHAR_CONSTANT("imfile"), sizeof("imfile") - 1));
 	CHKiRet(prop.ConstructFinalize(pInputName));
-
 finalize_it:
 ENDwillRun
 
+// TODO: refactor this into a generically-usable "atomic file creation" utility for
+// all kinds of "state files"
+static rsRetVal ATTR_NONNULL()
+atomicWriteStateFile(const char *fn, const char *content)
+{
+	DEFiRet;
+	const int fd = open(fn, O_CLOEXEC | O_NOCTTY | O_WRONLY | O_CREAT, 0600);
+	if(fd < 0) {
+		LogError(errno, RS_RET_IO_ERROR, "imfile: cannot open state file '%s' for "
+			"persisting file state - some data will probably be duplicated "
+			"on next startup", fn);
+		ABORT_FINALIZE(RS_RET_IO_ERROR);
+	}
+
+	const size_t toWrite = strlen(content);
+	const ssize_t w = write(fd, content, toWrite);
+	if(w != (ssize_t) toWrite) {
+		LogError(errno, RS_RET_IO_ERROR, "imfile: partial write to state file '%s' "
+			"this may cause trouble in the future. We will try to delete the "
+			"state file, as this provides most consistent state", fn);
+		unlink(fn);
+		ABORT_FINALIZE(RS_RET_IO_ERROR);
+	}
+
+finalize_it:
+	if(fd >= 0) {
+		close(fd);
+	}
+	RETiRet;
+}
+
+
 /* This function persists information for a specific file being monitored.
  * To do so, it simply persists the stream object. We do NOT abort on error
  * iRet as that makes matters worse (at least we can try persisting the others...).
@@ -2208,38 +2246,52 @@ static rsRetVal ATTR_NONNULL()
 persistStrmState(act_obj_t *const act)
 {
 	DEFiRet;
-	strm_t *psSF = NULL; /* state file (stream) */
-	size_t lenDir;
 	uchar statefile[MAXFNAME];
-
-	const instanceConf_t *const inst = act->edge->instarr[0];// TODO: same file, multiple instances?
+	uchar statefname[MAXFNAME];
 
 	uchar *const statefn = getStateFileName(act, statefile, sizeof(statefile));
-	DBGPRINTF("persisting state for '%s' to file '%s'\n", act->name, statefn);
-	CHKiRet(strm.Construct(&psSF));
-	lenDir = ustrlen(glbl.GetWorkDir());
-	if(lenDir > 0)
-		CHKiRet(strm.SetDir(psSF, glbl.GetWorkDir(), lenDir));
-	CHKiRet(strm.SettOperationsMode(psSF, STREAMMODE_WRITE_TRUNC));
-	CHKiRet(strm.SetsType(psSF, STREAMTYPE_FILE_SINGLE));
-	CHKiRet(strm.SetFName(psSF, statefn, strlen((char*) statefn)));
-	CHKiRet(strm.SetFileNotFoundError(psSF, inst->fileNotFoundError));
-	CHKiRet(strm.ConstructFinalize(psSF));
-
-	CHKiRet(strm.Serialize(act->pStrm, psSF));
-	CHKiRet(strm.Flush(psSF));
-
-	CHKiRet(strm.Destruct(&psSF));
+	getFullStateFileName(statefn, statefname, sizeof(statefname));
+	DBGPRINTF("persisting state for '%s', state file '%s'\n", act->name, statefname);
+
+	struct json_object *jval = NULL;
+	struct json_object *json = NULL;
+	CHKmalloc(json = json_object_new_object());
+	jval = json_object_new_string((char*) act->name);
+	json_object_object_add(json, "filename", jval);
+	jval = json_object_new_int(strmGetPrevWasNL(act->pStrm));
+	json_object_object_add(json, "prev_was_nl", jval);
+
+	/* we access some data items a bit dirty, as we need to refactor the whole
+	 * thing in any case - TODO
+	 */
+	jval = json_object_new_int64(act->pStrm->iCurrOffs);
+	json_object_object_add(json, "curr_offs", jval);
+	jval = json_object_new_int64(act->pStrm->strtOffs);
+	json_object_object_add(json, "strt_offs", jval);
 
-finalize_it:
-	if(psSF != NULL)
-		strm.Destruct(&psSF);
+	const uchar *const prevLineSegment = strmGetPrevLineSegment(act->pStrm);
+	if(prevLineSegment != NULL) {
+		jval = json_object_new_string((const char*) prevLineSegment);
+		json_object_object_add(json, "prev_line_segment", jval);
+	}
+
+	const uchar *const prevMsgSegment = strmGetPrevMsgSegment(act->pStrm);
+	if(prevMsgSegment != NULL) {
+		jval = json_object_new_string((const char*) prevMsgSegment);
+		json_object_object_add(json, "prev_msg_segment", jval);
+	}
 
+	const char *jstr =  json_object_to_json_string_ext(json, JSON_C_TO_STRING_SPACED);
+
+	CHKiRet(atomicWriteStateFile((const char*)statefname, jstr));
+	json_object_put(json);
+
+finalize_it:
 	if(iRet != RS_RET_OK) {
 		LogError(0, iRet, "imfile: could not persist state "
 				"file %s - data may be repeated on next "
 				"startup. Is WorkDirectory set?",
-				statefn);
+				statefname);
 	}
 
 	RETiRet;
diff --git a/runtime/stream.c b/runtime/stream.c
index cf16e1ffb1..1a644e84c0 100644
--- a/runtime/stream.c
+++ b/runtime/stream.c
@@ -16,7 +16,7 @@
  * it turns out to be problematic. Then, we need to quasi-refcount the number of accesses
  * to the object.
  *
- * Copyright 2008-2017 Rainer Gerhards and Adiscon GmbH.
+ * Copyright 2008-2018 Rainer Gerhards and Adiscon GmbH.
  *
  * This file is part of the rsyslog runtime library.
  *
@@ -91,6 +91,41 @@ static rsRetVal strmSeekCurrOffs(strm_t *pThis);
 
 /* methods */
 
+/* note: this may return NULL if not line segment is currently set  */
+// TODO: due to the cstrFinalize() this is not totally clean, albeit for our
+// current use case it does not hurt -- refactor! rgerhards, 2018-03-27
+const uchar * ATTR_NONNULL()
+strmGetPrevLineSegment(strm_t *const pThis)
+{
+	const uchar *ret = NULL;
+	if(pThis->prevLineSegment != NULL) {
+		cstrFinalize(pThis->prevLineSegment);
+		ret = rsCStrGetSzStrNoNULL(pThis->prevLineSegment);
+	}
+	return ret;
+}
+/* note: this may return NULL if not line segment is currently set  */
+// TODO: due to the cstrFinalize() this is not totally clean, albeit for our
+// current use case it does not hurt -- refactor! rgerhards, 2018-03-27
+const uchar * ATTR_NONNULL()
+strmGetPrevMsgSegment(strm_t *const pThis)
+{
+	const uchar *ret = NULL;
+	if(pThis->prevMsgSegment != NULL) {
+		cstrFinalize(pThis->prevMsgSegment);
+		ret = rsCStrGetSzStrNoNULL(pThis->prevMsgSegment);
+	}
+	return ret;
+}
+
+
+int ATTR_NONNULL()
+strmGetPrevWasNL(const strm_t *const pThis)
+{
+	return pThis->bPrevWasNL;
+}
+
+
 /* output (current) file name for debug log purposes. Falls back to various
  * levels of impreciseness if more precise name is not known.
  */
@@ -1024,6 +1059,7 @@ strmReadMultiLine(strm_t *pThis, cstr_t **ppCStr, regex_t *preg, const sbool bEs
 		pThis->strtOffs = pThis->iCurrOffs; /* we are at begin of next line */
 		cstrFinalize(*ppCStr);
 	} else {
+		dbgprintf("imfile timeout check: readTimeout %d, prevMsgSeg %p, lastRead %zu, readTimeout %zu\n", pThis->readTimeout, pThis->prevMsgSegment,(size_t) pThis->lastRead, (size_t)pThis->readTimeout);
 		if(   pThis->readTimeout
 		   && (pThis->prevMsgSegment != NULL)
 		   && (tCurr > pThis->lastRead + pThis->readTimeout)) {
@@ -2186,6 +2222,7 @@ static rsRetVal strmSerialize(strm_t *pThis, strm_t *pStrm)
 	l = pThis->strtOffs;
 	objSerializeSCALAR_VAR(pStrm, strtOffs, INT64, l);
 
+	dbgprintf("strmSerialize: pThis->prevLineSegment %p\n", pThis->prevLineSegment);
 	if(pThis->prevLineSegment != NULL) {
 		cstrFinalize(pThis->prevLineSegment);
 		objSerializePTR(pStrm, prevLineSegment, CSTR);
diff --git a/runtime/stream.h b/runtime/stream.h
index bafa5fbd37..3b80368d9f 100644
--- a/runtime/stream.h
+++ b/runtime/stream.h
@@ -41,7 +41,7 @@
  * deflateInit2(zstrmptr, 6, Z_DEFLATED, 31, 9, Z_DEFAULT_STRATEGY);
  * --------------------------------------------------------------------------
  * 
- * Copyright 2008-2016 Rainer Gerhards and Adiscon GmbH.
+ * Copyright 2008-2018 Rainer Gerhards and Adiscon GmbH.
  *
  * This file is part of the rsyslog runtime library.
  *
@@ -230,5 +230,8 @@ rsRetVal strmReadMultiLine(strm_t *pThis, cstr_t **ppCStr, regex_t *preg,
 int strmReadMultiLine_isTimedOut(const strm_t *const __restrict__ pThis);
 void strmDebugOutBuf(const strm_t *const pThis);
 void strmSetReadTimeout(strm_t *const __restrict__ pThis, const int val);
+const uchar * ATTR_NONNULL() strmGetPrevLineSegment(strm_t *const pThis);
+const uchar * ATTR_NONNULL() strmGetPrevMsgSegment(strm_t *const pThis);
+int ATTR_NONNULL() strmGetPrevWasNL(const strm_t *const pThis);
 
 #endif /* #ifndef STREAM_H_INCLUDED */
diff --git a/tests/imfile-endregex-timeout-with-shutdown-polling.sh b/tests/imfile-endregex-timeout-with-shutdown-polling.sh
index a2b660c28b..4bd7193644 100755
--- a/tests/imfile-endregex-timeout-with-shutdown-polling.sh
+++ b/tests/imfile-endregex-timeout-with-shutdown-polling.sh
@@ -1,19 +1,9 @@
 #!/bin/bash
 # This is part of the rsyslog testbench, licensed under ASL 2.0
-echo ======================================================================
-# Check if inotify header exist
-if [ -n "$(find /usr/include -name 'inotify.h' -print -quit)" ]; then
-	echo [imfile-endregex.sh]
-else
-	exit 77 # no inotify available, skip this test
-fi
 . $srcdir/diag.sh init
 . $srcdir/diag.sh generate-conf
 . $srcdir/diag.sh add-conf '
-module(load="../plugins/imfile/.libs/imfile"
-	mode="polling"
-	pollingInterval="2"
-      )
+module(load="../plugins/imfile/.libs/imfile" mode="polling" pollingInterval="1")
 
 input(type="imfile"
       File="./rsyslog.input"
@@ -39,7 +29,7 @@ if $msg contains "msgnum:" then
 # to pick up the data (IN MULTIPLE ITERATIONS!)
 echo 'msgnum:0
  msgnum:1' > rsyslog.input
-./msleep 8000
+./msleep 5000
 echo ' msgnum:2
  msgnum:3' >> rsyslog.input
 
@@ -47,14 +37,18 @@ echo ' msgnum:2
 # works across restarts.
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
+
+#echo DROPPING YOU TO BASH!
+#bash
+
 . $srcdir/diag.sh startup
 
 # new data
 echo ' msgnum:4' >> rsyslog.input
-./msleep 8000
+./msleep 5000
 echo ' msgnum:5
  msgnum:6' >> rsyslog.input
-./msleep 8000
+./msleep 5000
 
 # the next line terminates our test. It is NOT written to the output file,
 # as imfile waits whether or not there is a follow-up line that it needs
@@ -65,13 +59,13 @@ echo ' msgnum:5
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
 
-echo 'HEADER msgnum:0\\n msgnum:1
-HEADER  msgnum:2\\n msgnum:3\\n msgnum:4
-HEADER  msgnum:5\\n msgnum:6' | cmp rsyslog.out.log
+printf 'HEADER msgnum:0\\\\n msgnum:1
+HEADER  msgnum:2\\\\n msgnum:3\\\\n msgnum:4
+HEADER  msgnum:5\\\\n msgnum:6\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
-  exit 1
+  . $srcdir/diag.sh error-exit 1
 fi;
 
 . $srcdir/diag.sh exit
diff --git a/tests/imfile-readmode2-with-persists-data-during-stop.sh b/tests/imfile-readmode2-with-persists-data-during-stop.sh
index 2b5e75f217..d0bb303faa 100755
--- a/tests/imfile-readmode2-with-persists-data-during-stop.sh
+++ b/tests/imfile-readmode2-with-persists-data-during-stop.sh
@@ -25,6 +25,7 @@ echo stopping rsyslog
 # polling loop properly picks up that data. Note that even in
 # inotify case we do have one polling loop at startup, as this
 # is required to find data written while we were stopped.
+ls -l test-spool
 
 echo 'msgnum:3
  msgnum:4' >> rsyslog.input
